setwd("C:/Users/Windows8/Dropbox/Costruzioni idrauliche/Parte2_Fognature/20150519_Costruzioni Idrauliche/Precipitazioni orarie")
list.files()
read.table("Dati pluviometrici.txt", header=TRUE) -> data
# read.table("Dati scrosci.txt", header=TRUE) -> data2
data
data[1,]
data[,2] -> data1h
data1h
hist(data1h,breaks=10,xlab="Precipitazion in mm",ylab="Frequenza",main="Istogramma 1 h")
length(data1h)
ecdf(data1h -> x)
plot(x,xlab="h[mm]",ylab="P[H<h]",type="l",col="red")

rep(c(1,3,6,12,24),each=40) -> h
c(data$X1h,data$X3h,data$X6h,data$X12h,data$X24h) -> hh

boxplot(hh ~ h,xlab="durata [ore]",ylab="Precipitazione (mm)",main="Precipitazioni Massime")

# 1 H

# Metodo dei momenti

# Caricare pacchetto evd
# Calcolo media e varianza
m1h <- mean(data1h)
v1h <- var(data1h)
# Fattore di scala
b1.gumbel <- sqrt(v1h)*sqrt(6)/pi
b1.gumbel
b.gumbel <- function(datah){sqrt(var(datah))*sqrt(6)/pi}
b.gumbel(data1h)
# Fattore di localizzazione, con 0.5772156649 = numero di Eulero-Mascheroni
a.gumbel <- function(datah,b){mean(datah)-b*0.5772156649}
a.gumbel(data1h,b1.gumbel) -> a1.gumbel
a.gumbel(data1h,b1.gumbel)
# Disegno curva Gumbel (per ordinare i dati si usa il comand sort)
z <- sort(data1h)
plot(z,pgumbel(z,loc=a1.gumbel,scale=b1.gumbel),type="l",col="red",xlab="h[mm]",ylab="P(H<h)", main="Frequenza di non superamento 1 h")


# Minimi quadrati

# Doppio logaritmo dei dati
ecdf(data1h) -> F
F(sort(data1h))
# Il minore ha probab 1/40 (la serie  composta da 40 dati), il maggiore 1
-log(-log(F(sort(data1h))))
# Problema:l'ultimo numero va ad infinito,  necessario eliminarlo
F(sort(data1h)[-40])
-log(-log(F(sort(data1h))[-40]))
-log(-log(F(sort(data1h))[-40])) -> Yi
F(sort(data1h)[-length(data1h)])
-log(-log(F(sort(data1h))[-length(data1h)]))
-log(-log(F(sort(data1h))[-length(data1h)])) -> Yi
# Interpolazione lineare
lsfit(sort(data1h)[-40],Yi) -> fts
fts$coefficients
fts$coefficients[[1]]
# Estrazione dei coefficienti
fts$coefficients[[2]]
fts$coefficients[[1]] -> d
fts$coefficients[[2]] -> m
# Si definiscono i parametri a e b di Gumbel.
b2.gumbel <- 1/m
b2.gumbel
a2.gumbel <- -d*b2.gumbel
a2.gumbel


# Metodo della massima verosimiglianza (maximum likelihood)

# Caricare pacchetto MASS

fitdistr(data1h,densfun=dgumbel,start=list(loc=a1.gumbel,scale=b1.gumbel)) -> mlab
mlab
mlab$estimate[[1]] -> a3.gumbel
mlab$estimate[[2]] -> b3.gumbel
a3.gumbel
b3.gumbel

#stampo (guarda in aiuto la curva gumbel). a1.gumbel  parametro di localizzazione, b1  parametro di scala
plot(z,pgumbel(z,loc=a1.gumbel,scale=b1.gumbel),type="l",col="red",xlab="h[mm]",ylab="P(H<h)", main="Frequenza di non superamento 1 h")
lines(z,pgumbel(z,loc=a2.gumbel,scale=b2.gumbel),type="l",col="blue")
lines(z,pgumbel(z,loc=a3.gumbel,scale=b3.gumbel),type="l",col="green")
lines(ecdf(data1h))
legend(28,0.4,legend=c("Momenti", "Minimi quadrati", "Max verosimiglianza"),col=c("red","blue","green"),lwd=2)


#---------------------------------------------
#Rassumendo:Abbiamo 3 coppie di valori
v=c(a1.gumbel, a2.gumbel, a3.gumbel, b1.gumbel, b2.gumbel, b3.gumbel)
v

#Metodo momenti
a1.gumbel
b1.gumbel

#Minimi quadrati
a2.gumbel
b2.gumbel

#Massima verosimiglianza
a3.gumbel
b3.gumbel
#----------------------------------------------

#Test di Pearson

# Metodo dei momenti
q <- c(0.2,0.4,0.6,0.8)
qgumbel(q,loc=a1.gumbel,scale=b1.gumbel) -> qi
c(0,F(qi)*40) -> no1
c(F(qi)*40,40) -> no2
no2-no1 -> no
sum(no)
0.2*length(data1h) -> deltap
deltap
X2.momenti <- sum((no-deltap)^2)/deltap
X2.momenti

# Metodo dei minimi quadrati
qgumbel(q,loc=a2.gumbel,scale=b2.gumbel) -> qi
c(0,F(qi)*40) -> no1
c(F(qi)*40,40) -> no2
no2-no1 -> no
0.2*length(data1h) -> deltap
deltap
X2.minimi <- sum((no-deltap)^2)/deltap
X2.minimi

# Metodo della max verosimiglianza
qgumbel(q,loc=a3.gumbel,scale=b3.gumbel) -> qi
c(0,F(qi)*40) -> no1
c(F(qi)*40,40) -> no2
no2-no1 -> no
0.2*length(data1h) -> deltap
deltap
X2.maxv <- sum((no-deltap)^2)/deltap
X2.maxv

#Vince chi ha il chi quadro minore, cio minimi quadrati
X2.momenti
X2.minimi
X2.maxv


# 3 H

data[,3] -> data3h
data3h
hist(data3h,breaks=10,xlab="Precipitazion in mm",ylab="Frequenza",main="Istogramma 3 h")
length(data3h)
ecdf(data3h -> x)
plot(x,xlab="h[mm]",ylab="P[H<h]",type="l",col="red")

# Metodo dei momenti

m3h <- mean(data3h)
v3h <- var(data3h)
b1_3h.gumbel <- sqrt(v3h)*sqrt(6)/pi
b1_3h.gumbel
b_3h.gumbel <- function(datah){sqrt(var(datah))*sqrt(6)/pi}
b_3h.gumbel(data3h)
a.gumbel <- function(datah,b){mean(datah)-b*0.5772156649}
a.gumbel(data3h,b1_3h.gumbel) -> a1_3h.gumbel
a.gumbel(data3h,b1_3h.gumbel)
z <- sort(data3h)

#Minimi quadrati
ecdf(data3h) -> F
F(sort(data3h))
-log(-log(F(sort(data3h))))
F(sort(data3h)[-40])
-log(-log(F(sort(data3h))[-40]))
-log(-log(F(sort(data3h))[-40])) -> Yi
F(sort(data3h)[-length(data3h)])
-log(-log(F(sort(data3h))[-length(data3h)]))
-log(-log(F(sort(data3h))[-length(data3h)])) -> Yi
lsfit(sort(data3h)[-40],Yi) -> fts
fts$coefficients
fts$coefficients[[1]]
fts$coefficients[[2]]
fts$coefficients[[1]] -> d
fts$coefficients[[2]] -> m
b2_3h.gumbel <- 1/m
b2_3h.gumbel
a2_3h.gumbel <- -d*b2_3h.gumbel
a2_3h.gumbel

#Metodo della massima verosimiglianza(maximum likelihood)
# pacchetto Mass
fitdistr(data3h,densfun=dgumbel,start=list(loc=a1_3h.gumbel,scale=b1_3h.gumbel)) -> mlab
mlab
mlab$estimate[[1]] -> a3_3h.gumbel
mlab$estimate[[2]] -> b3_3h.gumbel
a3_3h.gumbel
b3_3h.gumbel

plot(z,pgumbel(z,loc=a1_3h.gumbel,scale=b1_3h.gumbel),type="l",col="red",xlab="h[mm]",ylab="P(H<h)", main="Frequenza di non superamento 3 h")
lines(z,pgumbel(z,loc=a2_3h.gumbel,scale=b2_3h.gumbel),type="l",col="blue")
lines(z,pgumbel(z,loc=a3_3h.gumbel,scale=b3_3h.gumbel),type="l",col="green")
lines(ecdf(data3h))
legend(42,0.4,legend=c("Momenti", "Minimi quadrati", "Max verosimiglianza"),col=c("red","blue","green"),lwd=2)


#---------------------------------------------
#Rassumendo:Abbiamo 3 coppie di valori
v=c(a1_3h.gumbel, a2_3h.gumbel, a3_3h.gumbel, b1_3h.gumbel, b2_3h.gumbel, b3_3h.gumbel)
v

#Metodo momenti
a1_3h.gumbel
b1_3h.gumbel

#Minimi quadrati
a2_3h.gumbel
b2_3h.gumbel

#Massima verosimiglianza
a3_3h.gumbel
b3_3h.gumbel
#----------------------------------------------

#Test di Pearson

# Metodo dei momenti
q <- c(0.2,0.4,0.6,0.8)
qgumbel(q,loc=a1_3h.gumbel,scale=b1_3h.gumbel) -> qi
c(0,F(qi)*40) -> no1
c(F(qi)*40,40) -> no2
no2-no1 -> no
sum(no)
0.2*length(data3h) -> deltap
deltap
X2_3h.momenti <- sum((no-deltap)^2)/deltap
X2_3h.momenti

# Metodo dei minimi quadrati
qgumbel(q,loc=a2_3h.gumbel,scale=b2_3h.gumbel) -> qi
c(0,F(qi)*40) -> no1
c(F(qi)*40,40) -> no2
no2-no1 -> no
0.2*length(data3h) -> deltap
deltap
X2_3h.minimi <- sum((no-deltap)^2)/deltap
X2_3h.minimi

# Metodo della max verosimiglianza
qgumbel(q,loc=a3_3h.gumbel,scale=b3_3h.gumbel) -> qi
c(0,F(qi)*40) -> no1
c(F(qi)*40,40) -> no2
no2-no1 -> no
0.2*length(data3h) -> deltap
deltap
X2_3h.maxv <- sum((no-deltap)^2)/deltap
X2_3h.maxv

#Vince chi ha il chi quadro minore, cio minimi quadrati
X2_3h.momenti
X2_3h.minimi
X2_3h.maxv


# 6 H

data[,4] -> data6h
data6h
hist(data6h,breaks=10,xlab="Precipitazion in mm",ylab="Frequenza",main="Istogramma 6 h")
length(data6h)
ecdf(data6h -> x)
plot(x,xlab="h[mm]",ylab="P[H<h]",type="l",col="red")


# Metodo dei momenti

m6h <- mean(data6h)
v6h <- var(data6h)
b1_6h.gumbel <- sqrt(v6h)*sqrt(6)/pi
b1_6h.gumbel
b_6h.gumbel <- function(datah){sqrt(var(datah))*sqrt(6)/pi}
b_6h.gumbel(data6h)
a.gumbel <- function(datah,b){mean(datah)-b*0.5772156649}
a.gumbel(data6h,b1_6h.gumbel) -> a1_6h.gumbel
a.gumbel(data6h,b1_6h.gumbel)
z <- sort(data6h)

#Minimi quadrati
ecdf(data6h) -> F
F(sort(data6h))
-log(-log(F(sort(data6h))))
F(sort(data6h)[-40])
-log(-log(F(sort(data6h))[-40]))
-log(-log(F(sort(data6h))[-40])) -> Yi
F(sort(data6h)[-length(data6h)])
-log(-log(F(sort(data6h))[-length(data6h)]))
-log(-log(F(sort(data6h))[-length(data6h)])) -> Yi
lsfit(sort(data6h)[-40],Yi) -> fts
fts$coefficients
fts$coefficients[[1]]
fts$coefficients[[2]]
fts$coefficients[[1]] -> d
fts$coefficients[[2]] -> m
b2_6h.gumbel <- 1/m
b2_6h.gumbel
a2_6h.gumbel <- -d*b2_6h.gumbel
a2_6h.gumbel

#Metodo della massima verosimiglianza(maximum likelihood)
# pacchetto Mass
fitdistr(data6h,densfun=dgumbel,start=list(loc=a1_6h.gumbel,scale=b1_6h.gumbel)) -> mlab
mlab
mlab$estimate[[1]] -> a3_6h.gumbel
mlab$estimate[[2]] -> b3_6h.gumbel
a3_6h.gumbel
b3_6h.gumbel

plot(z,pgumbel(z,loc=a1_6h.gumbel,scale=b1_6h.gumbel),type="l",col="red",xlab="h[mm]",ylab="P(H<h)", main="Frequenza di non superamento 6 h")
lines(z,pgumbel(z,loc=a2_6h.gumbel,scale=b2_6h.gumbel),type="l",col="blue")
lines(z,pgumbel(z,loc=a3_6h.gumbel,scale=b3_6h.gumbel),type="l",col="green")
lines(ecdf(data6h))
legend(58,0.4,legend=c("Momenti", "Minimi quadrati", "Max verosimiglianza"),col=c("red","blue","green"),lwd=2)

#---------------------------------------------
#Rassumendo:Abbiamo 3 coppie di valori
v=c(a1_6h.gumbel, a2_6h.gumbel, a3_6h.gumbel, b1_6h.gumbel, b2_6h.gumbel, b3_6h.gumbel)
v

#Metodo momenti
a1_6h.gumbel
b1_6h.gumbel

#Minimi quadrati
a2_6h.gumbel
b2_6h.gumbel

#Massima verosimiglianza
a3_6h.gumbel
b3_6h.gumbel
#----------------------------------------------

#Test di Pearson

# Metodo dei momenti
q <- c(0.2,0.4,0.6,0.8)
qgumbel(q,loc=a1_6h.gumbel,scale=b1_6h.gumbel) -> qi
c(0,F(qi)*40) -> no1
c(F(qi)*40,40) -> no2
no2-no1 -> no
sum(no)
0.2*length(data6h) -> deltap
deltap
X2_6h.momenti <- sum((no-deltap)^2)/deltap
X2_6h.momenti

# Metodo dei minimi quadrati
qgumbel(q,loc=a2_6h.gumbel,scale=b2_6h.gumbel) -> qi
c(0,F(qi)*40) -> no1
c(F(qi)*40,40) -> no2
no2-no1 -> no
0.2*length(data6h) -> deltap
deltap
X2_6h.minimi <- sum((no-deltap)^2)/deltap
X2_6h.minimi

# Metodo della max verosimiglianza
qgumbel(q,loc=a3_6h.gumbel,scale=b3_6h.gumbel) -> qi
c(0,F(qi)*40) -> no1
c(F(qi)*40,40) -> no2
no2-no1 -> no
0.2*length(data6h) -> deltap
deltap
X2_6h.maxv <- sum((no-deltap)^2)/deltap
X2_6h.maxv

#Vince chi ha il chi quadro minore, cio momenti
X2_6h.momenti
X2_6h.minimi
X2_6h.maxv



# 12 H

data[,5] -> data12h
data12h
hist(data12h,breaks=10,xlab="Precipitazion in mm",ylab="Frequenza",main="Istogramma 12 h")
length(data12h)
ecdf(data12h -> x)
plot(x,xlab="h[mm]",ylab="P[H<h]",type="l",col="red")


# Metodo dei momenti

m12h <- mean(data12h)
v12h <- var(data12h)
b1_12h.gumbel <- sqrt(v12h)*sqrt(6)/pi
b1_12h.gumbel
b_12h.gumbel <- function(datah){sqrt(var(datah))*sqrt(6)/pi}
b_12h.gumbel(data12h)
a.gumbel <- function(datah,b){mean(datah)-b*0.5772156649}
a.gumbel(data12h,b1_12h.gumbel) -> a1_12h.gumbel
a.gumbel(data12h,b1_12h.gumbel)
z <- sort(data12h)

#Minimi quadrati
ecdf(data12h) -> F
F(sort(data12h))
-log(-log(F(sort(data12h))))
F(sort(data12h)[-40])
-log(-log(F(sort(data12h))[-40]))
-log(-log(F(sort(data12h))[-40])) -> Yi
F(sort(data12h)[-length(data12h)])
-log(-log(F(sort(data12h))[-length(data12h)]))
-log(-log(F(sort(data12h))[-length(data12h)])) -> Yi
lsfit(sort(data12h)[-40],Yi) -> fts
fts$coefficients
fts$coefficients[[1]]
fts$coefficients[[2]]
fts$coefficients[[1]] -> d
fts$coefficients[[2]] -> m
b2_12h.gumbel <- 1/m
b2_12h.gumbel
a2_12h.gumbel <- -d*b2_12h.gumbel
a2_12h.gumbel

#Metodo della massima verosimiglianza(maximum likelihood)
# pacchetto Mass
fitdistr(data12h,densfun=dgumbel,start=list(loc=a1_12h.gumbel,scale=b1_12h.gumbel)) -> mlab
mlab
mlab$estimate[[1]] -> a3_12h.gumbel
mlab$estimate[[2]] -> b3_12h.gumbel
a3_12h.gumbel
b3_12h.gumbel

plot(z,pgumbel(z,loc=a1_12h.gumbel,scale=b1_12h.gumbel),type="l",col="red",xlab="h[mm]",ylab="P(H<h)", main="Frequenza di non superamento 12 h")
lines(z,pgumbel(z,loc=a2_12h.gumbel,scale=b2_12h.gumbel),type="l",col="blue")
lines(z,pgumbel(z,loc=a3_12h.gumbel,scale=b3_12h.gumbel),type="l",col="green")
lines(ecdf(data12h))
legend(85,0.4,legend=c("Momenti", "Minimi quadrati", "Max verosimiglianza"),col=c("red","blue","green"),lwd=2)


#---------------------------------------------
#Rassumendo:Abbiamo 3 coppie di valori
v=c(a1_12h.gumbel, a2_12h.gumbel, a3_12h.gumbel, b1_12h.gumbel, b2_12h.gumbel, b3_12h.gumbel)
v

#Metodo momenti
a1_12h.gumbel
b1_12h.gumbel

#Minimi quadrati
a2_12h.gumbel
b2_12h.gumbel

#Massima verosimiglianza
a3_12h.gumbel
b3_12h.gumbel
#----------------------------------------------

#Test di Pearson

# Metodo dei momenti
q <- c(0.2,0.4,0.6,0.8)
qgumbel(q,loc=a1_12h.gumbel,scale=b1_12h.gumbel) -> qi
c(0,F(qi)*40) -> no1
c(F(qi)*40,40) -> no2
no2-no1 -> no
sum(no)
0.2*length(data12h) -> deltap
deltap
X2_12h.momenti <- sum((no-deltap)^2)/deltap
X2_12h.momenti

# Metodo dei minimi quadrati
qgumbel(q,loc=a2_12h.gumbel,scale=b2_12h.gumbel) -> qi
c(0,F(qi)*40) -> no1
c(F(qi)*40,40) -> no2
no2-no1 -> no
0.2*length(data12h) -> deltap
deltap
X2_12h.minimi <- sum((no-deltap)^2)/deltap
X2_12h.minimi

# Metodo della max verosimiglianza
qgumbel(q,loc=a3_12h.gumbel,scale=b3_12h.gumbel) -> qi
c(0,F(qi)*40) -> no1
c(F(qi)*40,40) -> no2
no2-no1 -> no
0.2*length(data12h) -> deltap
deltap
X2_12h.maxv <- sum((no-deltap)^2)/deltap
X2_12h.maxv

#Vince chi ha il chi quadro minore, cio momenti
X2_12h.momenti
X2_12h.minimi
X2_12h.maxv



# 24 H

data[,6] -> data24h
data24h
data24h[!is.na(data24h)] -> data24h
data24h
hist(data24h,breaks=10,xlab="Precipitazion in mm",ylab="Frequenza",main="Istogramma 24 h")
length(data24h)
ecdf(data24h -> x)
plot(x,xlab="h[mm]",ylab="P[H<h]",type="l",col="red")


# Metodo dei momenti

length(data24h)
m24h <- mean(data24h)
v24h <- var(data24h)
b1_24h.gumbel <- sqrt(v24h)*sqrt(6)/pi
b1_24h.gumbel
b_24h.gumbel <- function(datah){sqrt(var(datah))*sqrt(6)/pi}
b_24h.gumbel(data24h)
a.gumbel <- function(datah,b){mean(datah)-b*0.5772156649}
a.gumbel(data24h,b1_24h.gumbel) -> a1_24h.gumbel
a.gumbel(data24h,b1_24h.gumbel)
z <- sort(data24h)

#Minimi quadrati
ecdf(data24h) -> F
F(sort(data24h))
-log(-log(F(sort(data24h))))
F(sort(data24h)[-39])
-log(-log(F(sort(data24h))[-39]))
-log(-log(F(sort(data24h))[-39])) -> Yi
F(sort(data24h)[-length(data24h)])
-log(-log(F(sort(data24h))[-length(data24h)]))
-log(-log(F(sort(data24h))[-length(data24h)])) -> Yi
lsfit(sort(data24h)[-39],Yi) -> fts
fts$coefficients
fts$coefficients[[1]]
fts$coefficients[[2]]
fts$coefficients[[1]] -> d
fts$coefficients[[2]] -> m
b2_24h.gumbel <- 1/m
b2_24h.gumbel
a2_24h.gumbel <- -d*b2_24h.gumbel
a2_24h.gumbel

#Metodo della massima verosimiglianza(maximum likelihood)
# pacchetto Mass
fitdistr(data24h,densfun=dgumbel,start=list(loc=a1_24h.gumbel,scale=b1_24h.gumbel)) -> mlab
mlab
mlab$estimate[[1]] -> a3_24h.gumbel
mlab$estimate[[2]] -> b3_24h.gumbel
a3_24h.gumbel
b3_24h.gumbel

plot(z,pgumbel(z,loc=a1_24h.gumbel,scale=b1_24h.gumbel),type="l",col="red",xlab="h[mm]",ylab="P(H<h)", main="Frequenza di non superamento 24 h")
lines(z,pgumbel(z,loc=a2_24h.gumbel,scale=b2_24h.gumbel),type="l",col="blue")
lines(z,pgumbel(z,loc=a3_24h.gumbel,scale=b3_24h.gumbel),type="l",col="green")
lines(ecdf(data24h))
legend(105,0.4,legend=c("Momenti", "Minimi quadrati", "Max verosimiglianza"),col=c("red","blue","green"),lwd=2)


#---------------------------------------------
#Rassumendo:Abbiamo 3 coppie di valori
v=c(a1_24h.gumbel, a2_24h.gumbel, a3_24h.gumbel, b1_24h.gumbel, b2_24h.gumbel, b3_24h.gumbel)
v

#Metodo momenti
a1_24h.gumbel
b1_24h.gumbel

#Minimi quadrati
a2_24h.gumbel
b2_24h.gumbel

#Massima verosimiglianza
a3_24h.gumbel
b3_24h.gumbel
#----------------------------------------------

#Test di Pearson

# Metodo dei momenti
q <- c(0.2,0.4,0.6,0.8)
qgumbel(q,loc=a1_24h.gumbel,scale=b1_24h.gumbel) -> qi
c(0,F(qi)*39) -> no1
c(F(qi)*39,39) -> no2
no2-no1 -> no
sum(no)
0.2*length(data24h) -> deltap
deltap
X2_24h.momenti <- sum((no-deltap)^2)/deltap
X2_24h.momenti

# Metodo dei minimi quadrati
qgumbel(q,loc=a2_24h.gumbel,scale=b2_24h.gumbel) -> qi
c(0,F(qi)*39) -> no1
c(F(qi)*39,39) -> no2
no2-no1 -> no
0.2*length(data24h) -> deltap
deltap
X2_24h.minimi <- sum((no-deltap)^2)/deltap
X2_24h.minimi

# Metodo della max verosimiglianza
qgumbel(q,loc=a3_24h.gumbel,scale=b3_24h.gumbel) -> qi
c(0,F(qi)*39) -> no1
c(F(qi)*39,39) -> no2
no2-no1 -> no
0.2*length(data24h) -> deltap
deltap
X2_24h.maxv <- sum((no-deltap)^2)/deltap
X2_24h.maxv

#Vince chi ha il chi quadro minore, cio momenti
X2_24h.momenti
X2_24h.minimi
X2_24h.maxv



# Curve di probabilit di Gumbel
seq(from=1, to=150,by=0.1) -> x
plot(x,pgumbel(x,loc=a1.gumbel,scale=b1.gumbel),type="l",col="red",xlab="Precipitazione [mm]",ylab="P[h]", main="Curve di probabilit di Gumbel")
lines(x,pgumbel(x,loc=a1_3h.gumbel,scale=b1_3h.gumbel),type="l",col="dark green")
lines(x,pgumbel(x,loc=a1_6h.gumbel,scale=b1_6h.gumbel),type="l",col="blue")
lines(x,pgumbel(x,loc=a1_12h.gumbel,scale=b1_12h.gumbel),type="l",col="dark red")
lines(x,pgumbel(x,loc=a1_24h.gumbel,scale=b1_24h.gumbel),type="l",col="dark blue")
text(17,0.6,"1h",cex=0.8)
text(33,0.55,"3h",cex=0.8)
text(43,0.50,"6h",cex=0.8)
text(57,0.45,"12h",cex=0.8)
text(75,0.40,"24h",cex=0.8)

# Distribuzione di probabilit di Gumbel
plot(x,dgumbel(x,loc=a1.gumbel,scale=b1.gumbel),type="l",col="red",xlab="Precipitazione [mm]",ylab="P[h]",main="Distribuzione di probabilit di Gumbel")
lines(x,dgumbel(x,loc=a1_3h.gumbel,scale=b1_3h.gumbel),type="l",col="dark green")
lines(x,dgumbel(x,loc=a1_6h.gumbel,scale=b1_6h.gumbel),type="l",col="blue")
lines(x,dgumbel(x,loc=a1_12h.gumbel,scale=b1_12h.gumbel),type="l",col="dark red")
lines(x,dgumbel(x,loc=a1_24h.gumbel,scale=b1_24h.gumbel),type="l",col="dark blue")
text(12,0.06,"1h",cex=0.8)
text(32,0.045,"3h",cex=0.8)
text(46,0.032,"6h",cex=0.8)
text(55,0.025,"12h",cex=0.8)
text(81,0.018,"24h",cex=0.8)


# Tempo di ritorno: 10 anni
c(qgumbel(0.9,loc=a1.gumbel,scale=b1.gumbel),qgumbel(0.9,loc=a1_3h.gumbel,scale=b1_3h.gumbel),qgumbel(0.9,loc=a1_6h.gumbel,scale=b1_6h.gumbel),qgumbel(0.9,loc=a1_12h.gumbel,scale=b1_12h.gumbel),qgumbel(0.9,loc=a1_24h.gumbel,scale=b1_24h.gumbel))-> h10
durate=c(1,3,6,12,24)
d=seq(from=1, to=24, by=0.1)
lsfit(log(durate),log(h10)) ->ft10
ft10$coefficients
exp(ft10$coefficients[[1]])

# Tempo di ritorno: 20 anni
c(qgumbel(0.95,loc=a1.gumbel,scale=b1.gumbel),qgumbel(0.95,loc=a1_3h.gumbel,scale=b1_3h.gumbel),qgumbel(0.95,loc=a1_6h.gumbel,scale=b1_6h.gumbel),qgumbel(0.95,loc=a1_12h.gumbel,scale=b1_12h.gumbel),qgumbel(0.95,loc=a1_24h.gumbel,scale=b1_24h.gumbel))-> h20
lsfit(log(durate),log(h20)) ->ft20
ft20$coefficients
exp(ft20$coefficients[[1]])


# Tempo di ritorno: 5 anni
c(qgumbel(0.8,loc=a1.gumbel,scale=b1.gumbel),qgumbel(0.8,loc=a1_3h.gumbel,scale=b1_3h.gumbel),qgumbel(0.8,loc=a1_6h.gumbel,scale=b1_6h.gumbel),qgumbel(0.8,loc=a1_12h.gumbel,scale=b1_12h.gumbel),qgumbel(0.8,loc=a1_24h.gumbel,scale=b1_24h.gumbel))-> h05
lsfit(log(durate),log(h05)) ->ft05
ft05$coefficients
exp(ft05$coefficients[[1]])



# Linee segnalatrici di possibilit pluviometrica
plot(d,exp(ft10$coefficients[[1]])*d^ft10$coefficients[[2]],type="l",xlab="t [ore]",ylab="h [mm]",main="Linee Segnalitrici di Possibilita' Pluviometrica")
lines(d,exp(ft20$coefficients[[1]])*d^ft20$coefficients[[2]],type="l",col="blue")
lines(d,exp(ft05$coefficients[[1]])*d^ft05$coefficients[[2]],type="l",col="red")
points(durate,h10,pch=0)
points(durate,h20,pch=1)
points(durate,h05,pch=2)
legend(20,60,legend=c("Tr=10", "Tr=20", "Tr=5"),col=c("black","blue","red"),lwd=2)


# Linee segnalatrici di possibilit pluviometrica (grafico bi-logaritmico)
plot(d,exp(ft10$coefficients[[1]])*d^ft10$coefficients[[2]],type="l",xlab="t [ore]",ylab="h [mm]",main="Linee Segnalitrici di Possibilita' Pluviometrica",log="xy")
lines(d,exp(ft20$coefficients[[1]])*d^ft20$coefficients[[2]],type="l",col="blue",log="xy")
lines(d,exp(ft05$coefficients[[1]])*d^ft05$coefficients[[2]],type="l",col="red",log="xy")
points(durate,h10,pch=0)
points(durate,h20,pch=1)
points(durate,h05,pch=2)
legend(13,50,legend=c("Tr=10", "Tr=20", "Tr=5"),col=c("black","blue","red"),lwd=2)