setwd("C:/Users/Windows8/Dropbox/Costruzioni idrauliche/Parte2_Fognature/20150519_Costruzioni Idrauliche/Lez3")
list.files()
read.table("Dati scrosci.txt", header=TRUE) -> data
data

rep(c(15,30,45),each=40) -> h
c(data$X15m,data$X30m,data$X45m) -> hh

boxplot(hh ~ h,xlab="durata [ore]",ylab="Precipitazione (mm)",main="Precipitazioni Massime")

# 15 min

data[,2] -> data15
data15
data15[!is.na(data15)] -> data15
data15
hist(data15,breaks=10,xlab="Precipitazion in mm",ylab="Frequenza",main="Istogramma 15 min")
length(data15)
ecdf(data15 -> x)
plot(x,xlab="h[mm]",ylab="P[H<h]",type="l",col="red")


# Metodo dei momenti
m15 <- mean(data15)
v15 <- var(data15)
b1_15.gumbel <- sqrt(v15)*sqrt(6)/pi
b1_15.gumbel
b_15.gumbel <- function(datah){sqrt(var(datah))*sqrt(6)/pi}
b_15.gumbel(data15)
a.gumbel <- function(datah,b){mean(datah)-b*0.5772156649}
a.gumbel(data15,b1_15.gumbel) -> a1_15.gumbel
a.gumbel(data15,b1_15.gumbel)
z <- sort(data15)

#Minimi quadrati
ecdf(data15) -> F
F(sort(data15))
-log(-log(F(sort(data15))))
F(sort(data15)[-25])
-log(-log(F(sort(data15))[-25]))
-log(-log(F(sort(data15))[-25])) -> Yi
F(sort(data15)[-length(data15)])
-log(-log(F(sort(data15))[-length(data15)]))
-log(-log(F(sort(data15))[-length(data15)])) -> Yi
lsfit(sort(data15)[-25],Yi) -> fts
fts$coefficients
fts$coefficients[[1]]
fts$coefficients[[2]]
fts$coefficients[[1]] -> d
fts$coefficients[[2]] -> m
b2_15.gumbel <- 1/m
b2_15.gumbel
a2_15.gumbel <- -d*b2_15.gumbel
a2_15.gumbel

#Metodo della massima verosimiglianza(maximum likelihood)
# pacchetto Mass
fitdistr(data15,densfun=dgumbel,start=list(loc=a1_15.gumbel,scale=b1_15.gumbel)) -> mlab
mlab
mlab$estimate[[1]] -> a3_15.gumbel
mlab$estimate[[2]] -> b3_15.gumbel
a3_15.gumbel
b3_15.gumbel

plot(z,pgumbel(z,loc=a1_15.gumbel,scale=b1_15.gumbel),type="l",col="red",xlab="h[mm]",ylab="P(H<h)", main="Frequenza di non superamento 15 min")
lines(z,pgumbel(z,loc=a2_15.gumbel,scale=b2_15.gumbel),type="l",col="blue")
lines(z,pgumbel(z,loc=a3_15.gumbel,scale=b3_15.gumbel),type="l",col="green")
lines(ecdf(data15))
legend(14,0.4,legend=c("Momenti", "Minimi quadrati", "Max verosimiglianza"),col=c("red","blue","green"),lwd=2)

#Test di Pearson

# Metodo dei momenti
q <- c(0.2,0.4,0.6,0.8)
qgumbel(q,loc=a1_15.gumbel,scale=b1_15.gumbel) -> qi
c(0,F(qi)*25) -> no1
c(F(qi)*25,25) -> no2
no2-no1 -> no
sum(no)
0.2*length(data15) -> deltap
deltap
X2_15.momenti <- sum((no-deltap)^2)/deltap
X2_15.momenti

# Metodo dei minimi quadrati
qgumbel(q,loc=a2_15.gumbel,scale=b2_15.gumbel) -> qi
c(0,F(qi)*25) -> no1
c(F(qi)*25,25) -> no2
no2-no1 -> no
0.2*length(data15) -> deltap
deltap
X2_15.minimi <- sum((no-deltap)^2)/deltap
X2_15.minimi

# Metodo della max verosimiglianza
qgumbel(q,loc=a3_15.gumbel,scale=b3_15.gumbel) -> qi
c(0,F(qi)*25) -> no1
c(F(qi)*25,25) -> no2
no2-no1 -> no
0.2*length(data15) -> deltap
deltap
X2_15.maxv <- sum((no-deltap)^2)/deltap
X2_15.maxv

#Vince chi ha il chi quadro minore, cio max verosimiglianza
X2_15.momenti
X2_15.minimi
X2_15.maxv

# 30 min

data[,3] -> data30
data30
data30[!is.na(data30)] -> data30
data30
hist(data30,breaks=10,xlab="Precipitazion in mm",ylab="Frequenza",main="Istogramma 30 min")
length(data30)
ecdf(data30 -> x)
plot(x,xlab="h[mm]",ylab="P[H<h]",type="l",col="red")


# Metodo dei momenti
m30 <- mean(data30)
v30 <- var(data30)
b1_30.gumbel <- sqrt(v30)*sqrt(6)/pi
b1_30.gumbel
b_30.gumbel <- function(datah){sqrt(var(datah))*sqrt(6)/pi}
b_30.gumbel(data30)
a.gumbel <- function(datah,b){mean(datah)-b*0.5772156649}
a.gumbel(data30,b1_30.gumbel) -> a1_30.gumbel
a.gumbel(data30,b1_30.gumbel)
z <- sort(data30)

#Minimi quadrati
ecdf(data30) -> F
F(sort(data30))
-log(-log(F(sort(data30))))
F(sort(data30)[-31])
-log(-log(F(sort(data30))[-31]))
-log(-log(F(sort(data30))[-31])) -> Yi
F(sort(data30)[-length(data30)])
-log(-log(F(sort(data30))[-length(data30)]))
-log(-log(F(sort(data30))[-length(data30)])) -> Yi
lsfit(sort(data30)[-31],Yi) -> fts
fts$coefficients
fts$coefficients[[1]]
fts$coefficients[[2]]
fts$coefficients[[1]] -> d
fts$coefficients[[2]] -> m
b2_30.gumbel <- 1/m
b2_30.gumbel
a2_30.gumbel <- -d*b2_30.gumbel
a2_30.gumbel

#Metodo della massima verosimiglianza(maximum likelihood)
# pacchetto Mass
fitdistr(data30,densfun=dgumbel,start=list(loc=a1_30.gumbel,scale=b1_30.gumbel)) -> mlab
mlab
mlab$estimate[[1]] -> a3_30.gumbel
mlab$estimate[[2]] -> b3_30.gumbel
a3_30.gumbel
b3_30.gumbel

plot(z,pgumbel(z,loc=a1_30.gumbel,scale=b1_30.gumbel),type="l",col="red",xlab="h[mm]",ylab="P(H<h)", main="Frequenza di non superamento 30 min")
lines(z,pgumbel(z,loc=a2_30.gumbel,scale=b2_30.gumbel),type="l",col="blue")
lines(z,pgumbel(z,loc=a3_30.gumbel,scale=b3_30.gumbel),type="l",col="green")
lines(ecdf(data30))
legend(20,0.4,legend=c("Momenti", "Minimi quadrati", "Max verosimiglianza"),col=c("red","blue","green"),lwd=2)

#Test di Pearson

# Metodo dei momenti
q <- c(0.2,0.4,0.6,0.8)
qgumbel(q,loc=a1_30.gumbel,scale=b1_30.gumbel) -> qi
c(0,F(qi)*31) -> no1
c(F(qi)*31,31) -> no2
no2-no1 -> no
sum(no)
0.2*length(data30) -> deltap
deltap
X2_30.momenti <- sum((no-deltap)^2)/deltap
X2_30.momenti

# Metodo dei minimi quadrati
qgumbel(q,loc=a2_30.gumbel,scale=b2_30.gumbel) -> qi
c(0,F(qi)*31) -> no1
c(F(qi)*31,31) -> no2
no2-no1 -> no
0.2*length(data30) -> deltap
deltap
X2_30.minimi <- sum((no-deltap)^2)/deltap
X2_30.minimi

# Metodo della max verosimiglianza
qgumbel(q,loc=a3_30.gumbel,scale=b3_30.gumbel) -> qi
c(0,F(qi)*31) -> no1
c(F(qi)*31,31) -> no2
no2-no1 -> no
0.2*length(data30) -> deltap
deltap
X2_30.maxv <- sum((no-deltap)^2)/deltap
X2_30.maxv

#Vince chi ha il chi quadro minore, cio max verosimiglianza
X2_30.momenti
X2_30.minimi
X2_30.maxv

# 45 min

data[,4] -> data45
data45
data45[!is.na(data45)] -> data45
data45
hist(data45,breaks=10,xlab="Precipitazion in mm",ylab="Frequenza",main="Istogramma 45 min")
length(data45)
ecdf(data45 -> x)
plot(x,xlab="h[mm]",ylab="P[H<h]",type="l",col="red")


# Metodo dei momenti

m45 <- mean(data45)
v45 <- var(data45)
b1_45.gumbel <- sqrt(v45)*sqrt(6)/pi
b1_45.gumbel
b_45.gumbel <- function(datah){sqrt(var(datah))*sqrt(6)/pi}
b_45.gumbel(data45)
a.gumbel <- function(datah,b){mean(datah)-b*0.5772156649}
a.gumbel(data45,b1_45.gumbel) -> a1_45.gumbel
a.gumbel(data45,b1_45.gumbel)
z <- sort(data45)

#Minimi quadrati
ecdf(data45) -> F
F(sort(data45))
-log(-log(F(sort(data45))))
F(sort(data45)[-22])
-log(-log(F(sort(data45))[-22]))
-log(-log(F(sort(data45))[-22])) -> Yi
F(sort(data45)[-length(data45)])
-log(-log(F(sort(data45))[-length(data45)]))
-log(-log(F(sort(data45))[-length(data45)])) -> Yi
lsfit(sort(data45)[-22],Yi) -> fts
fts$coefficients
fts$coefficients[[1]]
fts$coefficients[[2]]
fts$coefficients[[1]] -> d
fts$coefficients[[2]] -> m
b2_45.gumbel <- 1/m
b2_45.gumbel
a2_45.gumbel <- -d*b2_45.gumbel
a2_45.gumbel

#Metodo della massima verosimiglianza(maximum likelihood)
# pacchetto Mass
fitdistr(data45,densfun=dgumbel,start=list(loc=a1_45.gumbel,scale=b1_45.gumbel)) -> mlab
mlab
mlab$estimate[[1]] -> a3_45.gumbel
mlab$estimate[[2]] -> b3_45.gumbel
a3_45.gumbel
b3_45.gumbel

plot(z,pgumbel(z,loc=a1_45.gumbel,scale=b1_45.gumbel),type="l",col="red",xlab="h[mm]",ylab="P(H<h)", main="Frequenza di non superamento 45 min")
lines(z,pgumbel(z,loc=a2_45.gumbel,scale=b2_45.gumbel),type="l",col="blue")
lines(z,pgumbel(z,loc=a3_45.gumbel,scale=b3_45.gumbel),type="l",col="green")
lines(ecdf(data45))
legend(22,0.4,legend=c("Momenti", "Minimi quadrati", "Max verosimiglianza"),col=c("red","blue","green"),lwd=2)

#Test di Pearson

# Metodo dei momenti
q <- c(0.2,0.4,0.6,0.8)
qgumbel(q,loc=a1_45.gumbel,scale=b1_45.gumbel) -> qi
c(0,F(qi)*22) -> no1
c(F(qi)*22,22) -> no2
no2-no1 -> no
sum(no)
0.2*length(data45) -> deltap
deltap
X2_45.momenti <- sum((no-deltap)^2)/deltap
X2_45.momenti

# Metodo dei minimi quadrati
qgumbel(q,loc=a2_45.gumbel,scale=b2_45.gumbel) -> qi
c(0,F(qi)*22) -> no1
c(F(qi)*22,22) -> no2
no2-no1 -> no
0.2*length(data45) -> deltap
deltap
X2_45.minimi <- sum((no-deltap)^2)/deltap
X2_45.minimi

# Metodo della max verosimiglianza
qgumbel(q,loc=a3_45.gumbel,scale=b3_45.gumbel) -> qi
c(0,F(qi)*22) -> no1
c(F(qi)*22,22) -> no2
no2-no1 -> no
0.2*length(data45) -> deltap
deltap
X2_45.maxv <- sum((no-deltap)^2)/deltap
X2_45.maxv

#Vince chi ha il chi quadro minore, cio minimi quadrati
X2_45.momenti
X2_45.minimi
X2_45.maxv



# Curve di probabilit di Gumbel
seq(from=1, to=100,by=0.1) -> x
plot(x,pgumbel(x,loc=a1_15.gumbel,scale=b1_15.gumbel),type="l",col="red",xlab="Precipitazione [mm]",ylab="P[h]", main="Curve di probabilit di Gumbel")
lines(x,pgumbel(x,loc=a1_30.gumbel,scale=b1_30.gumbel),type="l",col="dark green")
lines(x,pgumbel(x,loc=a1_45.gumbel,scale=b1_45.gumbel),type="l",col="blue")
legend(60,0.4,legend=c("15 min", "30 min", "45 min"),col=c("red","dark green","blue"),lwd=2)

# Distribuzione di probabilit di Gumbel
plot(x,dgumbel(x,loc=a1_15.gumbel,scale=b1_15.gumbel),type="l",col="red",xlab="Precipitazione [mm]",ylab="P[h]",main="Distribuzione di probabilit di Gumbel")
lines(x,dgumbel(x,loc=a1_30.gumbel,scale=b1_30.gumbel),type="l",col="dark green")
lines(x,dgumbel(x,loc=a1_45.gumbel,scale=b1_45.gumbel),type="l",col="blue")
legend(60,0.04,legend=c("15 min", "30 min", "45 min"),col=c("red","dark green","blue"),lwd=2)


# Tempo di ritorno: 10 anni
c(qgumbel(0.9,loc=a1_15.gumbel,scale=b1_15.gumbel),qgumbel(0.9,loc=a1_30.gumbel,scale=b1_30.gumbel),qgumbel(0.9,loc=a1_45.gumbel,scale=b1_45.gumbel))-> h10
h10
durate=c(15,30,45)
d=seq(from=1, to=45, by=0.1)
lsfit(log(d),log(h10)) ->ft10
ft10$coefficients
exp(ft10$coefficients[[1]])

# Tempo di ritorno: 20 anni
c(qgumbel(0.95,loc=a1_15.gumbel,scale=b1_15.gumbel),qgumbel(0.95,loc=a1_30.gumbel,scale=b1_30.gumbel),qgumbel(0.95,loc=a1_45.gumbel,scale=b1_45.gumbel))-> h20
lsfit(log(d),log(h20)) ->ft20

# Tempo di ritorno: 5 anni
c(qgumbel(0.8,loc=a1_15.gumbel,scale=b1_15.gumbel),qgumbel(0.8,loc=a1_30.gumbel,scale=b1_30.gumbel),qgumbel(0.8,loc=a1_45.gumbel,scale=b1_45.gumbel))-> h05
lsfit(log(d),log(h05)) ->ft05


# Linee segnalatrici di possibilit pluviometrica
plot(d,exp(ft10$coefficients[[1]])*d^ft10$coefficients[[2]],type="l",xlab="t [min]",ylab="h [mm]",main="Linee Segnalitrici di Possibilita' Pluviometrica")
lines(d,exp(ft20$coefficients[[1]])*d^ft20$coefficients[[2]],type="l",col="blue")
lines(d,exp(ft05$coefficients[[1]])*d^ft05$coefficients[[2]],type="l",col="red")
points(durate,h10,pch=0)
points(durate,h20,pch=1)
points(durate,h05,pch=2)
legend(20,60,legend=c("Tr=10", "Tr=20", "Tr=5"),col=c("black","blue","red"),lwd=2)


# Linee segnalatrici di possibilit pluviometrica (grafico bi-logaritmico)
plot(d,exp(ft10$coefficients[[1]])*d^ft10$coefficients[[2]],type="l",xlab="t [min]",ylab="h [mm]",main="Linee Segnalitrici di Possibilita' Pluviometrica",log="xy")
lines(d,exp(ft20$coefficients[[1]])*d^ft20$coefficients[[2]],type="l",col="blue",log="xy")
lines(d,exp(ft05$coefficients[[1]])*d^ft05$coefficients[[2]],type="l",col="red",log="xy")
points(durate,h10,pch=0)
points(durate,h20,pch=1)
points(durate,h05,pch=2)
legend(13,50,legend=c("Tr=10", "Tr=20", "Tr=5"),col=c("black","blue","red"),lwd=2)
